<?php

namespace Controller;
 
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;
use Exception; 

class PedidoController extends \Zeedhi\Framework\Controller\Simple {
 
    protected $pedidoController;
    
    public function __construct(\Service\PedidoService $pedidoService) {
        $this->pedidoService = $pedidoService;
    }
    
	public function connect(Request $request, Response $response){
	    
	    if($request->getMethod() == 'GET'){
	        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("response", array('status' => 'it works!')));
	    }else if($request->getMethod() == 'POST'){
    	    $row = $request->getRow();
	        if(isset($row['HASH']) && $row['HASH'] == '7f02bd90ece137b215ed136dd83a2a02'){
    	        $this->pedidoService->connect($response, $row);
	        }else{
	            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("response", array('status' => 'access denied!')));
	        }
	    }
	}
	
	public function config(Request $request, Response $response){
	    $row = $request->getRow();
	    $this->pedidoService->config($response, $row);
	}
	
	public function buscarProduto(Request $request, Response $response) {
	    $row = $request->getRow();
	    $this->pedidoService->buscarProduto($response, $row);
	}
	
	public function consumirProduto(Request $request, Response $response) {
        $row = $request->getRow();
        $this->pedidoService->consumirProduto($response, $row);
    }
    
    public function registraCodExterno(Request $request, Response $response) {
        $dataSet = $request->getDataSet();
        $this->pedidoService->registraCodExterno($response, $dataSet);
    }
    
    public function consultaProduto(Request $request, Response $response) {
        $row = $request->getRow();
        $this->pedidoService->consultaProduto($response, $row);
    }
    
    public function produtoAtualizado(Request $request, Response $response) {
        $dataSet = $request->getDataSet();
        $this->pedidoService->produtoAtualizado($response, $dataSet);
    }
    
    public function atualizaProduto(Request $request, Response $response) {
        $dataSet = $request->getDataSet();
        $this->pedidoService->atualizaProduto($response, $dataSet);
    }
    
    public function consumirCliente(Request $request, Response $response) {
        $row = $request->getRow();
        $this->pedidoService->consumirCliente($response, $row);
    }
    
    public function registraClienteExterno(Request $request, Response $response){
        $dataSet = $request->getDataSet();
        $this->pedidoService->registraClienteExterno($response, $dataSet);
    }
    
    public function consultaCliente(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->consultaCliente($response, $row);
    }
    
    public function clienteAtualizado(Request $request, Response $response){
        $dataSet = $request->getDataSet();
        $this->pedidoService->clienteAtualizado($response, $dataSet);
    } 
    
    public function registraPedido(Request $request, Response $response){
    	$dataSet = $request->getDataSet();
    	$rows = $dataSet->getRows();
    	
    // 	var_dump('to na integração');die;
    	
    	/*
    	 *  Gera log para controle de recebimento de pedidos. Deixar comentado por padrão.
    	 *  Caso o cliente queira utilizar o log, descomentar a chamada da função e dar permissão 777 na pasta Log.
    	*/
        // $this->geraLogRegistraPedido($rows);
    	
    	$email_retorno1 = $rows[0]['RETORNO_EMAIL1'];
		$email_retorno2 = $rows[0]['RETORNO_EMAIL2'];
    	$connection = $rows[0];
    	unset($rows[0]);
    	
		$this->pedidoService->registraPedido($request, $response, $rows, $email_retorno1, $email_retorno2, $connection);
    }
    
    public function gravaTeste(Request $request, Response $response){
    	$dataSet = $request->getDataSet();
    	$rows = $dataSet->getRows();
    	
    	$email_retorno1 = 'teste';
		$email_retorno2 = 'teste';//$rows[0]['RETORNO_EMAIL2'];
    	$connection = $rows[0];
    	unset($rows[0]);
    	
		$this->pedidoService->gravaTeste($request, $response, $rows, $email_retorno1, $email_retorno2, $connection);
    }
    
    public function geraLogRegistraPedido ($row){
        $arquivo = __DIR__."/Log/log_registraPedido.json";
		
		$pedido = json_encode($row);
		
		$conteudoArquivo = file_get_contents($arquivo);
		if($conteudoArquivo){
			file_put_contents($arquivo, $conteudoArquivo.",\n".$pedido);
		}else{
			file_put_contents($arquivo, $pedido);
		}
    }
    
    public function registraClienteAux(Request $request, Response $response){
        $rows = $request->getDataSet();
        $this->pedidoService->registraClienteAux($response, $rows);
    }
    
    public function registraProdutoAux(Request $request, Response $response){
        $rows = $request->getDataSet();
        $this->pedidoService->registraProdutoAux($response, $rows);
    }
    
    public function dbHandle(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->dbHandle($response, $row);
    }
    
    public function verificarPendenciaFinanceira(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->verificarPendenciaFinanceira($response, $row);
    }
    
    /** INÍCIO NOVOS METODOS PARA SELLENT **/
    
    public function getCliente(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->getCliente($response, $row);
    }
    
    public function getProduto(Request $request, Response $response){
        $row = $request->getRow();
        
        $requestFields = ['CDPRECOBASE'];
        $emptyFields = [];
        foreach($requestFields as $field){
            if(empty($row[$field]))
                array_push($emptyFields, $field);
        }
        
        if(!empty($emptyFields))
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("response", array('status' => 'error', 'requestFields' => $emptyFields)));
        else
            $this->pedidoService->getProduto($response, $row);
    }
    
    public function getPedido(Request $request, Response $response){
        $row = $request->getRow();
        
        $requestFields = ['CDFILIAL', 'DTINICIAL', 'DTFINAL'];
        $emptyFields = [];
        foreach($requestFields as $field){
            if(empty($row[$field]))
                array_push($emptyFields, $field);
        }
        
        if(!empty($emptyFields))
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("response", array('status' => 'error', 'requestFields' => $emptyFields)));
        else
            $this->pedidoService->getPedido($response, $row); 
    }
    
    public function getTransportadora(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->getTransportadora($response, $row);
    }
    
    public function getPreco(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->getPreco($response, $row);
    }
    
    public function getModalidade(Request $request, Response $response){
        $row = $request->getRow();
        $this->pedidoService->getModalidade($response, $row);
    }
    
    /** FIM NOVOS METODOS PARA SELLENT **/
}