<?php

namespace Teknisa\Libs\Util\Repositories;

use Doctrine\ORM\EntityManager;

class ZhuLog {
    /** @var EntityManager $entityManager */
    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    /**
     * @param $filters
     * @param $limit
     * @param $offset
     * @return array
     */
    public function getZhuLog($filters, $limit, $offset){
        $query = "SELECT *
                    FROM ZHU_LOG
                   WHERE 1 = 1
                      $filters
                   ORDER BY TIMESTAMP DESC, ROUTE";
        $query = $this->getPaginatedQuery($query, $limit, $offset);
        return $this->entityManager->getConnection()->fetchAll($query);
    }

    private function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $max = $offset + $limit;
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $max . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $max;
            }
        }

        return $query;
    }
} 