CREATE TABLE ZHU_LOG
(
    TYPE VARCHAR2(10) NOT NULL,
    ROUTE VARCHAR2(4000) NOT NULL,
    HTTP_RESPONSE_CODE NUMBER(3,0),
    REQ_ID VARCHAR2(30) NOT NULL,
    METHOD VARCHAR2(10) NOT NULL,
    REQUEST_TYPE VARCHAR2(20) NOT NULL,
    TIMESTAMP DATE NOT NULL,
    USER_DATA VARCHAR2(4000),
    CONTEXT_DATA VARCHAR2(4000),
    CONTENT CLOB NOT NULL
);

ALTER TABLE ZHU_LOG
ADD CONSTRAINT ZHU_LOG_METHOD CHECK
(METHOD IN ('POST', 'GET', 'PUT', 'DELETE', 'OPTIONS'))
ENABLE;

ALTER TABLE ZHU_LOG
ADD CONSTRAINT ZHU_LOG_REQUEST_TYPE CHECK
(REQUEST_TYPE IN ('Empty', 'FilterData', 'Row', 'DataSet'))
ENABLE;

ALTER TABLE ZHU_LOG
ADD CONSTRAINT ZHU_LOG_TYPE CHECK
(TYPE IN ('REQUEST', 'RESPONSE'))
ENABLE;